from PyChipsUser import *
from FmcTluI2c import *

import sys
import time

boardIpAddr = "192.168.200.16"
boardPortNum = 50001

addrTable = AddressTable("./aida_mini_tlu_addr_map.txt")

board = ChipsBusUdp(addrTable, boardIpAddr, boardPortNum)

# Check the bus for I2C devices
boardi2c = FmcTluI2c(board)

boardFirmware = board.read("FirmwareId")
print "Firmware version = " , hex(boardFirmware)

print "Scanning I2C bus:"
scanResults = boardi2c.i2c_scan()
print scanResults

boardId = boardi2c.get_serial_number()
print "FMC-TLU serial number = " , boardId

resetClocks = 0
resetSerdes = 1 

# set DACs to -200mV
print "Setting all threshold DAC to -200mV "
boardi2c.set_threshold_voltage(7, -0.200)

clockStatus = board.read("LogicClocksCSR")
print "Clock status = " , hex(clockStatus)

if resetClocks:
    print "Resetting clocks"
    board.write("LogicRst", 1 )

    clockStatus = board.read("LogicClocksCSR")
    print "Clock status after reset = " , hex(clockStatus)

#print "Setting PLL input to ext. clk"
#board.write("LogicRst", 0 )
#clockStatus = board.read("LogicClocksCSR")
#print "Clock status = " , hex(clockStatus)


inputStatus = board.read("SerdesRst")
print "Input status = " , hex(inputStatus)

if resetSerdes:
    board.write("SerdesRst", 0x00000003 )
    inputStatus = board.read("SerdesRst")
    print "Input status during reset = " , hex(inputStatus)

    board.write("SerdesRst", 0x00000000 )
    inputStatus = board.read("SerdesRst")
    print "Input status after reset = " , hex(inputStatus)

    board.write("SerdesRst", 0x00000004 )
    inputStatus = board.read("SerdesRst")
    print "Input status during calibration = " , hex(inputStatus)

    board.write("SerdesRst", 0x00000000 )
    inputStatus = board.read("SerdesRst")
    print "Input status after calibration = " , hex(inputStatus)


# Look at status of input IODELAYs
numLoops = 5

for iLoop in range(0,numLoops):

    inputStatus = board.read("SerdesRst")
    print "Input status = " , hex(inputStatus)

    count0 = board.read("ThrCount0R")
    print " Count 0 = " , count0

    count1 = board.read("ThrCount1R")
    print " Count 1 = " , count1

    count2 = board.read("ThrCount2R")
    print " Count 2 = " , count2

    count3 = board.read("ThrCount3R")
    print " Count 3 = " , count3

    time.sleep(1.0)


